from ....tl.tlobject import TLObject


class GetTmpPasswordRequest(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    account.getTmpPassword#4a82327e password_hash:bytes period:int = account.TmpPassword"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x4a82327e
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xb064992d

    def __init__(self, password_hash, period):
        """
        :param password_hash: Telegram type: "bytes".
        :param period: Telegram type: "int".

        :returns account.TmpPassword: Instance of TmpPassword.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.password_hash = password_hash
        self.period = period

    def to_dict(self):
        return {
            'password_hash': self.password_hash,
            'period': self.period,
        }

    def on_send(self, writer):
        writer.write_int(GetTmpPasswordRequest.constructor_id, signed=False)
        writer.tgwrite_bytes(self.password_hash)
        writer.write_int(self.period)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return GetTmpPasswordRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'account.getTmpPassword#4a82327e password_hash:bytes period:int = account.TmpPassword'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
