from ....tl.tlobject import TLObject


class CheckPhoneRequest(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    auth.checkPhone#6fe51dfb phone_number:string = auth.CheckedPhone"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x6fe51dfb
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x99a3d765

    def __init__(self, phone_number):
        """
        :param phone_number: Telegram type: "string".

        :returns auth.CheckedPhone: Instance of CheckedPhone.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.phone_number = phone_number

    def to_dict(self):
        return {
            'phone_number': self.phone_number,
        }

    def on_send(self, writer):
        writer.write_int(CheckPhoneRequest.constructor_id, signed=False)
        writer.tgwrite_string(self.phone_number)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return CheckPhoneRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'auth.checkPhone#6fe51dfb phone_number:string = auth.CheckedPhone'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
