from ....tl.tlobject import TLObject
from ....utils import get_input_channel


class DeleteMessagesRequest(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    channels.deleteMessages#84c1fd4e channel:InputChannel id:Vector<int> = messages.AffectedMessages"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x84c1fd4e
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xced3c06e

    def __init__(self, channel, id):
        """
        :param channel: Telegram type: "InputChannel".
        :param id: Telegram type: "int". Must be a list.

        :returns messages.AffectedMessages: Instance of AffectedMessages.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.channel = get_input_channel(channel)
        self.id = id

    def to_dict(self):
        return {
            'channel': None if self.channel is None else self.channel.to_dict(),
            'id': [] if self.id is None else self.id[:],
        }

    def on_send(self, writer):
        writer.write_int(DeleteMessagesRequest.constructor_id, signed=False)
        self.channel.on_send(writer)
        writer.write_int(0x1cb5c415, signed=False)  # Vector's constructor ID
        writer.write_int(len(self.id))
        for _x in self.id:
            writer.write_int(_x)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return DeleteMessagesRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'channels.deleteMessages#84c1fd4e channel:InputChannel id:Vector<int> = messages.AffectedMessages'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
