from ....tl.tlobject import TLObject
from ....utils import get_input_channel


class GetFullChannelRequest(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    channels.getFullChannel#08736a09 channel:InputChannel = messages.ChatFull"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x8736a09
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x225a5109

    def __init__(self, channel):
        """
        :param channel: Telegram type: "InputChannel".

        :returns messages.ChatFull: Instance of ChatFull.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.channel = get_input_channel(channel)

    def to_dict(self):
        return {
            'channel': None if self.channel is None else self.channel.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(GetFullChannelRequest.constructor_id, signed=False)
        self.channel.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return GetFullChannelRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'channels.getFullChannel#08736a09 channel:InputChannel = messages.ChatFull'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
