from ...tl.tlobject import TLObject


class InvokeWithLayerRequest(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    invokeWithLayer#da9b0d0d {X:Type} layer:int query:!X = X"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xda9b0d0d
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xb7b2364b

    def __init__(self, layer, query):
        """
        :param layer: Telegram type: "int".
        :param query: Telegram type: "X". Must be another TLObject request.

        :returns X: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.layer = layer
        self.query = query

    def to_dict(self):
        return {
            'layer': self.layer,
            'query': None if self.query is None else self.query.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(InvokeWithLayerRequest.constructor_id, signed=False)
        writer.write_int(self.layer)
        self.query.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return InvokeWithLayerRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'invokeWithLayer#da9b0d0d {X:Type} layer:int query:!X = X'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
