from ...tl.tlobject import TLObject


class InvokeWithoutUpdatesRequest(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    invokeWithoutUpdates#bf9459b7 {X:Type} query:!X = X"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xbf9459b7
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xb7b2364b

    def __init__(self, query):
        """
        :param query: Telegram type: "X". Must be another TLObject request.

        :returns X: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.query = query

    def to_dict(self):
        return {
            'query': None if self.query is None else self.query.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(InvokeWithoutUpdatesRequest.constructor_id, signed=False)
        self.query.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return InvokeWithoutUpdatesRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'invokeWithoutUpdates#bf9459b7 {X:Type} query:!X = X'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
