from ....tl.tlobject import TLObject
from ....utils import get_input_peer


class GetMessageEditDataRequest(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    messages.getMessageEditData#fda68d36 peer:InputPeer id:int = messages.MessageEditData"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xfda68d36
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xfb47949d

    def __init__(self, peer, id):
        """
        :param peer: Telegram type: "InputPeer".
        :param id: Telegram type: "int".

        :returns messages.MessageEditData: Instance of MessageEditData.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.peer = get_input_peer(peer)
        self.id = id

    def to_dict(self):
        return {
            'peer': None if self.peer is None else self.peer.to_dict(),
            'id': self.id,
        }

    def on_send(self, writer):
        writer.write_int(GetMessageEditDataRequest.constructor_id, signed=False)
        self.peer.on_send(writer)
        writer.write_int(self.id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return GetMessageEditDataRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.getMessageEditData#fda68d36 peer:InputPeer id:int = messages.MessageEditData'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
