from ....tl.tlobject import TLObject


class SetCallRatingRequest(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    phone.setCallRating#1c536a34 peer:InputPhoneCall rating:int comment:string = Updates"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x1c536a34
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x8af52aac

    def __init__(self, peer, rating, comment):
        """
        :param peer: Telegram type: "InputPhoneCall".
        :param rating: Telegram type: "int".
        :param comment: Telegram type: "string".

        :returns Updates: Instance of either UpdatesTooLong, UpdateShortMessage, UpdateShortChatMessage, UpdateShort, UpdatesCombined, UpdatesTg, UpdateShortSentMessage.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.peer = peer
        self.rating = rating
        self.comment = comment

    def to_dict(self):
        return {
            'peer': None if self.peer is None else self.peer.to_dict(),
            'rating': self.rating,
            'comment': self.comment,
        }

    def on_send(self, writer):
        writer.write_int(SetCallRatingRequest.constructor_id, signed=False)
        self.peer.on_send(writer)
        writer.write_int(self.rating)
        writer.tgwrite_string(self.comment)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return SetCallRatingRequest(None, None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'phone.setCallRating#1c536a34 peer:InputPhoneCall rating:int comment:string = Updates'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
