from ....tl.tlobject import TLObject


class RemoveStickerFromSetRequest(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    stickers.removeStickerFromSet#f7760f51 sticker:InputDocument = messages.StickerSet"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xf7760f51
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x9b704a5a

    def __init__(self, sticker):
        """
        :param sticker: Telegram type: "InputDocument".

        :returns messages.StickerSet: Instance of StickerSet.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.sticker = sticker

    def to_dict(self):
        return {
            'sticker': None if self.sticker is None else self.sticker.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(RemoveStickerFromSetRequest.constructor_id, signed=False)
        self.sticker.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return RemoveStickerFromSetRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'stickers.removeStickerFromSet#f7760f51 sticker:InputDocument = messages.StickerSet'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
