from ....tl.tlobject import TLObject


class GetCdnFileRequest(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    upload.getCdnFile#2000bcc3 file_token:bytes offset:int limit:int = upload.CdnFile"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x2000bcc3
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xf5ccf928

    def __init__(self, file_token, offset, limit):
        """
        :param file_token: Telegram type: "bytes".
        :param offset: Telegram type: "int".
        :param limit: Telegram type: "int".

        :returns upload.CdnFile: Instance of either CdnFileReuploadNeeded, CdnFile.
        """
        super().__init__()
        self.result = None
        self.content_related = True

        self.file_token = file_token
        self.offset = offset
        self.limit = limit

    def to_dict(self):
        return {
            'file_token': self.file_token,
            'offset': self.offset,
            'limit': self.limit,
        }

    def on_send(self, writer):
        writer.write_int(GetCdnFileRequest.constructor_id, signed=False)
        writer.tgwrite_bytes(self.file_token)
        writer.write_int(self.offset)
        writer.write_int(self.limit)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return GetCdnFileRequest(None, None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'upload.getCdnFile#2000bcc3 file_token:bytes offset:int limit:int = upload.CdnFile'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
