from ...tl.tlobject import TLObject


class ChannelAdminLogEventActionEditMessage(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    channelAdminLogEventActionEditMessage#709b2405 prev_message:Message new_message:Message = ChannelAdminLogEventAction"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x709b2405
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xb2b987f3

    def __init__(self, prev_message, new_message):
        """
        :param prev_message: Telegram type: "Message".
        :param new_message: Telegram type: "Message".

        Constructor for ChannelAdminLogEventAction: Instance of either ChannelAdminLogEventActionChangeTitle, ChannelAdminLogEventActionChangeAbout, ChannelAdminLogEventActionChangeUsername, ChannelAdminLogEventActionChangePhoto, ChannelAdminLogEventActionToggleInvites, ChannelAdminLogEventActionToggleSignatures, ChannelAdminLogEventActionUpdatePinned, ChannelAdminLogEventActionEditMessage, ChannelAdminLogEventActionDeleteMessage, ChannelAdminLogEventActionParticipantJoin, ChannelAdminLogEventActionParticipantLeave, ChannelAdminLogEventActionParticipantInvite, ChannelAdminLogEventActionParticipantToggleBan, ChannelAdminLogEventActionParticipantToggleAdmin.
        """
        super().__init__()

        self.prev_message = prev_message
        self.new_message = new_message

    def to_dict(self):
        return {
            'prev_message': None if self.prev_message is None else self.prev_message.to_dict(),
            'new_message': None if self.new_message is None else self.new_message.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(ChannelAdminLogEventActionEditMessage.constructor_id, signed=False)
        self.prev_message.on_send(writer)
        self.new_message.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return ChannelAdminLogEventActionEditMessage(None, None)

    def on_response(self, reader):
        self.prev_message = reader.tgread_object()
        self.new_message = reader.tgread_object()

    def __repr__(self):
        return 'channelAdminLogEventActionEditMessage#709b2405 prev_message:Message new_message:Message = ChannelAdminLogEventAction'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
