from ...tl.tlobject import TLObject


class GeoPoint(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    geoPoint#2049d70c long:double lat:double = GeoPoint"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x2049d70c
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xd610e16d

    def __init__(self, long, lat):
        """
        :param long: Telegram type: "double".
        :param lat: Telegram type: "double".

        Constructor for GeoPoint: Instance of either GeoPointEmpty, GeoPoint.
        """
        super().__init__()

        self.long = long
        self.lat = lat

    def to_dict(self):
        return {
            'long': self.long,
            'lat': self.lat,
        }

    def on_send(self, writer):
        writer.write_int(GeoPoint.constructor_id, signed=False)
        writer.write_double(self.long)
        writer.write_double(self.lat)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return GeoPoint(None, None)

    def on_response(self, reader):
        self.long = reader.read_double()
        self.lat = reader.read_double()

    def __repr__(self):
        return 'geoPoint#2049d70c long:double lat:double = GeoPoint'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
