from ...tl.tlobject import TLObject


class ImportedContact(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    importedContact#d0028438 user_id:int client_id:long = ImportedContact"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xd0028438
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xb545bbda

    def __init__(self, user_id, client_id):
        """
        :param user_id: Telegram type: "int".
        :param client_id: Telegram type: "long".

        Constructor for ImportedContact: Instance of ImportedContact.
        """
        super().__init__()

        self.user_id = user_id
        self.client_id = client_id

    def to_dict(self):
        return {
            'user_id': self.user_id,
            'client_id': self.client_id,
        }

    def on_send(self, writer):
        writer.write_int(ImportedContact.constructor_id, signed=False)
        writer.write_int(self.user_id)
        writer.write_long(self.client_id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return ImportedContact(None, None)

    def on_response(self, reader):
        self.user_id = reader.read_int()
        self.client_id = reader.read_long()

    def __repr__(self):
        return 'importedContact#d0028438 user_id:int client_id:long = ImportedContact'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
