from ...tl.tlobject import TLObject


class InputBotInlineMessageID(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    inputBotInlineMessageID#890c3d89 dc_id:int id:long access_hash:long = InputBotInlineMessageID"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x890c3d89
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x2dcd6300

    def __init__(self, dc_id, id, access_hash):
        """
        :param dc_id: Telegram type: "int".
        :param id: Telegram type: "long".
        :param access_hash: Telegram type: "long".

        Constructor for InputBotInlineMessageID: Instance of InputBotInlineMessageID.
        """
        super().__init__()

        self.dc_id = dc_id
        self.id = id
        self.access_hash = access_hash

    def to_dict(self):
        return {
            'dc_id': self.dc_id,
            'id': self.id,
            'access_hash': self.access_hash,
        }

    def on_send(self, writer):
        writer.write_int(InputBotInlineMessageID.constructor_id, signed=False)
        writer.write_int(self.dc_id)
        writer.write_long(self.id)
        writer.write_long(self.access_hash)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return InputBotInlineMessageID(None, None, None)

    def on_response(self, reader):
        self.dc_id = reader.read_int()
        self.id = reader.read_long()
        self.access_hash = reader.read_long()

    def __repr__(self):
        return 'inputBotInlineMessageID#890c3d89 dc_id:int id:long access_hash:long = InputBotInlineMessageID'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
