from ...tl.tlobject import TLObject


class InputGeoPoint(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    inputGeoPoint#f3b7acc9 lat:double long:double = InputGeoPoint"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xf3b7acc9
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x430d225

    def __init__(self, lat, long):
        """
        :param lat: Telegram type: "double".
        :param long: Telegram type: "double".

        Constructor for InputGeoPoint: Instance of either InputGeoPointEmpty, InputGeoPoint.
        """
        super().__init__()

        self.lat = lat
        self.long = long

    def to_dict(self):
        return {
            'lat': self.lat,
            'long': self.long,
        }

    def on_send(self, writer):
        writer.write_int(InputGeoPoint.constructor_id, signed=False)
        writer.write_double(self.lat)
        writer.write_double(self.long)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return InputGeoPoint(None, None)

    def on_response(self, reader):
        self.lat = reader.read_double()
        self.long = reader.read_double()

    def __repr__(self):
        return 'inputGeoPoint#f3b7acc9 lat:double long:double = InputGeoPoint'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
