from ...tl.tlobject import TLObject


class InputMessageEntityMentionName(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    inputMessageEntityMentionName#208e68c9 offset:int length:int user_id:InputUser = MessageEntity"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x208e68c9
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xcf6419dc

    def __init__(self, offset, length, user_id):
        """
        :param offset: Telegram type: "int".
        :param length: Telegram type: "int".
        :param user_id: Telegram type: "InputUser".

        Constructor for MessageEntity: Instance of either MessageEntityUnknown, MessageEntityMention, MessageEntityHashtag, MessageEntityBotCommand, MessageEntityUrl, MessageEntityEmail, MessageEntityBold, MessageEntityItalic, MessageEntityCode, MessageEntityPre, MessageEntityTextUrl, MessageEntityMentionName, InputMessageEntityMentionName.
        """
        super().__init__()

        self.offset = offset
        self.length = length
        self.user_id = user_id

    def to_dict(self):
        return {
            'offset': self.offset,
            'length': self.length,
            'user_id': None if self.user_id is None else self.user_id.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(InputMessageEntityMentionName.constructor_id, signed=False)
        writer.write_int(self.offset)
        writer.write_int(self.length)
        self.user_id.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return InputMessageEntityMentionName(None, None, None)

    def on_response(self, reader):
        self.offset = reader.read_int()
        self.length = reader.read_int()
        self.user_id = reader.tgread_object()

    def __repr__(self):
        return 'inputMessageEntityMentionName#208e68c9 offset:int length:int user_id:InputUser = MessageEntity'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
