from ...tl.tlobject import TLObject


class InputPeerChannel(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    inputPeerChannel#20adaef8 channel_id:int access_hash:long = InputPeer"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x20adaef8
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xc91c90b6

    def __init__(self, channel_id, access_hash):
        """
        :param channel_id: Telegram type: "int".
        :param access_hash: Telegram type: "long".

        Constructor for InputPeer: Instance of either InputPeerEmpty, InputPeerSelf, InputPeerChat, InputPeerUser, InputPeerChannel.
        """
        super().__init__()

        self.channel_id = channel_id
        self.access_hash = access_hash

    def to_dict(self):
        return {
            'channel_id': self.channel_id,
            'access_hash': self.access_hash,
        }

    def on_send(self, writer):
        writer.write_int(InputPeerChannel.constructor_id, signed=False)
        writer.write_int(self.channel_id)
        writer.write_long(self.access_hash)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return InputPeerChannel(None, None)

    def on_response(self, reader):
        self.channel_id = reader.read_int()
        self.access_hash = reader.read_long()

    def __repr__(self):
        return 'inputPeerChannel#20adaef8 channel_id:int access_hash:long = InputPeer'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
