from ...tl.tlobject import TLObject


class InputPrivacyValueAllowUsers(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    inputPrivacyValueAllowUsers#131cc67f users:Vector<InputUser> = InputPrivacyRule"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x131cc67f
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x5a3b6b22

    def __init__(self, users):
        """
        :param users: Telegram type: "InputUser". Must be a list.

        Constructor for InputPrivacyRule: Instance of either InputPrivacyValueAllowContacts, InputPrivacyValueAllowAll, InputPrivacyValueAllowUsers, InputPrivacyValueDisallowContacts, InputPrivacyValueDisallowAll, InputPrivacyValueDisallowUsers.
        """
        super().__init__()

        self.users = users

    def to_dict(self):
        return {
            'users': [] if self.users is None else [None if x is None else x.to_dict() for x in self.users],
        }

    def on_send(self, writer):
        writer.write_int(InputPrivacyValueAllowUsers.constructor_id, signed=False)
        writer.write_int(0x1cb5c415, signed=False)  # Vector's constructor ID
        writer.write_int(len(self.users))
        for _x in self.users:
            _x.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return InputPrivacyValueAllowUsers(None)

    def on_response(self, reader):
        reader.read_int()  # Vector's constructor ID
        self.users = []  # Initialize an empty list
        _len = reader.read_int()
        for _ in range(_len):
            _x = reader.tgread_object()
            self.users.append(_x)

    def __repr__(self):
        return 'inputPrivacyValueAllowUsers#131cc67f users:Vector<InputUser> = InputPrivacyRule'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
