from ...tl.tlobject import TLObject


class InputWebFileLocation(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    inputWebFileLocation#c239d686 url:string access_hash:long = InputWebFileLocation"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xc239d686
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xf72ed8d9

    def __init__(self, url, access_hash):
        """
        :param url: Telegram type: "string".
        :param access_hash: Telegram type: "long".

        Constructor for InputWebFileLocation: Instance of InputWebFileLocation.
        """
        super().__init__()

        self.url = url
        self.access_hash = access_hash

    def to_dict(self):
        return {
            'url': self.url,
            'access_hash': self.access_hash,
        }

    def on_send(self, writer):
        writer.write_int(InputWebFileLocation.constructor_id, signed=False)
        writer.tgwrite_string(self.url)
        writer.write_long(self.access_hash)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return InputWebFileLocation(None, None)

    def on_response(self, reader):
        self.url = reader.tgread_string()
        self.access_hash = reader.read_long()

    def __repr__(self):
        return 'inputWebFileLocation#c239d686 url:string access_hash:long = InputWebFileLocation'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
