from ...tl.tlobject import TLObject


class KeyboardButtonRow(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    keyboardButtonRow#77608b83 buttons:Vector<KeyboardButton> = KeyboardButtonRow"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x77608b83
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x847730ae

    def __init__(self, buttons):
        """
        :param buttons: Telegram type: "KeyboardButton". Must be a list.

        Constructor for KeyboardButtonRow: Instance of KeyboardButtonRow.
        """
        super().__init__()

        self.buttons = buttons

    def to_dict(self):
        return {
            'buttons': [] if self.buttons is None else [None if x is None else x.to_dict() for x in self.buttons],
        }

    def on_send(self, writer):
        writer.write_int(KeyboardButtonRow.constructor_id, signed=False)
        writer.write_int(0x1cb5c415, signed=False)  # Vector's constructor ID
        writer.write_int(len(self.buttons))
        for _x in self.buttons:
            _x.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return KeyboardButtonRow(None)

    def on_response(self, reader):
        reader.read_int()  # Vector's constructor ID
        self.buttons = []  # Initialize an empty list
        _len = reader.read_int()
        for _ in range(_len):
            _x = reader.tgread_object()
            self.buttons.append(_x)

    def __repr__(self):
        return 'keyboardButtonRow#77608b83 buttons:Vector<KeyboardButton> = KeyboardButtonRow'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
