from ...tl.tlobject import TLObject


class KeyboardButtonUrl(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    keyboardButtonUrl#258aff05 text:string url:string = KeyboardButton"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x258aff05
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xbad74a3

    def __init__(self, text, url):
        """
        :param text: Telegram type: "string".
        :param url: Telegram type: "string".

        Constructor for KeyboardButton: Instance of either KeyboardButton, KeyboardButtonUrl, KeyboardButtonCallback, KeyboardButtonRequestPhone, KeyboardButtonRequestGeoLocation, KeyboardButtonSwitchInline, KeyboardButtonGame, KeyboardButtonBuy.
        """
        super().__init__()

        self.text = text
        self.url = url

    def to_dict(self):
        return {
            'text': self.text,
            'url': self.url,
        }

    def on_send(self, writer):
        writer.write_int(KeyboardButtonUrl.constructor_id, signed=False)
        writer.tgwrite_string(self.text)
        writer.tgwrite_string(self.url)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return KeyboardButtonUrl(None, None)

    def on_response(self, reader):
        self.text = reader.tgread_string()
        self.url = reader.tgread_string()

    def __repr__(self):
        return 'keyboardButtonUrl#258aff05 text:string url:string = KeyboardButton'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
