from ...tl.tlobject import TLObject


class MessageActionGameScore(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    messageActionGameScore#92a72876 game_id:long score:int = MessageAction"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x92a72876
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x8680d126

    def __init__(self, game_id, score):
        """
        :param game_id: Telegram type: "long".
        :param score: Telegram type: "int".

        Constructor for MessageAction: Instance of either MessageActionEmpty, MessageActionChatCreate, MessageActionChatEditTitle, MessageActionChatEditPhoto, MessageActionChatDeletePhoto, MessageActionChatAddUser, MessageActionChatDeleteUser, MessageActionChatJoinedByLink, MessageActionChannelCreate, MessageActionChatMigrateTo, MessageActionChannelMigrateFrom, MessageActionPinMessage, MessageActionHistoryClear, MessageActionGameScore, MessageActionPaymentSentMe, MessageActionPaymentSent, MessageActionPhoneCall, MessageActionScreenshotTaken.
        """
        super().__init__()

        self.game_id = game_id
        self.score = score

    def to_dict(self):
        return {
            'game_id': self.game_id,
            'score': self.score,
        }

    def on_send(self, writer):
        writer.write_int(MessageActionGameScore.constructor_id, signed=False)
        writer.write_long(self.game_id)
        writer.write_int(self.score)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return MessageActionGameScore(None, None)

    def on_response(self, reader):
        self.game_id = reader.read_long()
        self.score = reader.read_int()

    def __repr__(self):
        return 'messageActionGameScore#92a72876 game_id:long score:int = MessageAction'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
