from ....tl.tlobject import TLObject


class ArchivedStickers(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    messages.archivedStickers#4fcba9c8 count:int sets:Vector<StickerSetCovered> = messages.ArchivedStickers"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x4fcba9c8
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x7296d771

    def __init__(self, count, sets):
        """
        :param count: Telegram type: "int".
        :param sets: Telegram type: "StickerSetCovered". Must be a list.

        Constructor for messages.ArchivedStickers: Instance of ArchivedStickers.
        """
        super().__init__()

        self.count = count
        self.sets = sets

    def to_dict(self):
        return {
            'count': self.count,
            'sets': [] if self.sets is None else [None if x is None else x.to_dict() for x in self.sets],
        }

    def on_send(self, writer):
        writer.write_int(ArchivedStickers.constructor_id, signed=False)
        writer.write_int(self.count)
        writer.write_int(0x1cb5c415, signed=False)  # Vector's constructor ID
        writer.write_int(len(self.sets))
        for _x in self.sets:
            _x.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return ArchivedStickers(None, None)

    def on_response(self, reader):
        self.count = reader.read_int()
        reader.read_int()  # Vector's constructor ID
        self.sets = []  # Initialize an empty list
        _len = reader.read_int()
        for _ in range(_len):
            _x = reader.tgread_object()
            self.sets.append(_x)

    def __repr__(self):
        return 'messages.archivedStickers#4fcba9c8 count:int sets:Vector<StickerSetCovered> = messages.ArchivedStickers'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
