from ...tl.tlobject import TLObject


class PageBlockPreformatted(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    pageBlockPreformatted#c070d93e text:RichText language:string = PageBlock"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xc070d93e
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x1aca5644

    def __init__(self, text, language):
        """
        :param text: Telegram type: "RichText".
        :param language: Telegram type: "string".

        Constructor for PageBlock: Instance of either PageBlockUnsupported, PageBlockTitle, PageBlockSubtitle, PageBlockAuthorDate, PageBlockHeader, PageBlockSubheader, PageBlockParagraph, PageBlockPreformatted, PageBlockFooter, PageBlockDivider, PageBlockAnchor, PageBlockList, PageBlockBlockquote, PageBlockPullquote, PageBlockPhoto, PageBlockVideo, PageBlockCover, PageBlockEmbed, PageBlockEmbedPost, PageBlockCollage, PageBlockSlideshow, PageBlockChannel, PageBlockAudio.
        """
        super().__init__()

        self.text = text
        self.language = language

    def to_dict(self):
        return {
            'text': None if self.text is None else self.text.to_dict(),
            'language': self.language,
        }

    def on_send(self, writer):
        writer.write_int(PageBlockPreformatted.constructor_id, signed=False)
        self.text.on_send(writer)
        writer.tgwrite_string(self.language)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return PageBlockPreformatted(None, None)

    def on_response(self, reader):
        self.text = reader.tgread_object()
        self.language = reader.tgread_string()

    def __repr__(self):
        return 'pageBlockPreformatted#c070d93e text:RichText language:string = PageBlock'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
