from ...tl.tlobject import TLObject


class PaymentSavedCredentialsCard(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    paymentSavedCredentialsCard#cdc27a1f id:string title:string = PaymentSavedCredentials"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xcdc27a1f
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xb3627ee3

    def __init__(self, id, title):
        """
        :param id: Telegram type: "string".
        :param title: Telegram type: "string".

        Constructor for PaymentSavedCredentials: Instance of PaymentSavedCredentialsCard.
        """
        super().__init__()

        self.id = id
        self.title = title

    def to_dict(self):
        return {
            'id': self.id,
            'title': self.title,
        }

    def on_send(self, writer):
        writer.write_int(PaymentSavedCredentialsCard.constructor_id, signed=False)
        writer.tgwrite_string(self.id)
        writer.tgwrite_string(self.title)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return PaymentSavedCredentialsCard(None, None)

    def on_response(self, reader):
        self.id = reader.tgread_string()
        self.title = reader.tgread_string()

    def __repr__(self):
        return 'paymentSavedCredentialsCard#cdc27a1f id:string title:string = PaymentSavedCredentials'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
