from ...tl.tlobject import TLObject


class PeerChat(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    peerChat#bad0e5bb chat_id:int = Peer"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xbad0e5bb
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x2d45687

    def __init__(self, chat_id):
        """
        :param chat_id: Telegram type: "int".

        Constructor for Peer: Instance of either PeerUser, PeerChat, PeerChannel.
        """
        super().__init__()

        self.chat_id = chat_id

    def to_dict(self):
        return {
            'chat_id': self.chat_id,
        }

    def on_send(self, writer):
        writer.write_int(PeerChat.constructor_id, signed=False)
        writer.write_int(self.chat_id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return PeerChat(None)

    def on_response(self, reader):
        self.chat_id = reader.read_int()

    def __repr__(self):
        return 'peerChat#bad0e5bb chat_id:int = Peer'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
