from ....tl.tlobject import TLObject


class Photo(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    photos.photo#20212ca8 photo:Photo users:Vector<User> = photos.Photo"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x20212ca8
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xc292bd24

    def __init__(self, photo, users):
        """
        :param photo: Telegram type: "Photo".
        :param users: Telegram type: "User". Must be a list.

        Constructor for photos.Photo: Instance of Photo.
        """
        super().__init__()

        self.photo = photo
        self.users = users

    def to_dict(self):
        return {
            'photo': None if self.photo is None else self.photo.to_dict(),
            'users': [] if self.users is None else [None if x is None else x.to_dict() for x in self.users],
        }

    def on_send(self, writer):
        writer.write_int(Photo.constructor_id, signed=False)
        self.photo.on_send(writer)
        writer.write_int(0x1cb5c415, signed=False)  # Vector's constructor ID
        writer.write_int(len(self.users))
        for _x in self.users:
            _x.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return Photo(None, None)

    def on_response(self, reader):
        self.photo = reader.tgread_object()
        reader.read_int()  # Vector's constructor ID
        self.users = []  # Initialize an empty list
        _len = reader.read_int()
        for _ in range(_len):
            _x = reader.tgread_object()
            self.users.append(_x)

    def __repr__(self):
        return 'photos.photo#20212ca8 photo:Photo users:Vector<User> = photos.Photo'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
