from ...tl.tlobject import TLObject


class ReceivedNotifyMessage(TLObject):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    receivedNotifyMessage#a384b779 id:int flags:int = ReceivedNotifyMessage"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xa384b779
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xa962381e

    def __init__(self, id, flags):
        """
        :param id: Telegram type: "int".
        :param flags: Telegram type: "int".

        Constructor for ReceivedNotifyMessage: Instance of ReceivedNotifyMessage.
        """
        super().__init__()

        self.id = id
        self.flags = flags

    def to_dict(self):
        return {
            'id': self.id,
            'flags': self.flags,
        }

    def on_send(self, writer):
        writer.write_int(ReceivedNotifyMessage.constructor_id, signed=False)
        writer.write_int(self.id)
        writer.write_int(self.flags)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return ReceivedNotifyMessage(None, None)

    def on_response(self, reader):
        self.id = reader.read_int()
        self.flags = reader.read_int()

    def __repr__(self):
        return 'receivedNotifyMessage#a384b779 id:int flags:int = ReceivedNotifyMessage'

    def __str__(self):
        return TLObject.pretty_format(self)

    def stringify(self):
        return TLObject.pretty_format(self, indent=0)
